unit unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Edit1: TEdit;
    StringGrid1: TStringGrid;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    procedure PopulateGrid;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  fpspreadsheet, xlsbiff8;

{ TForm1 }

procedure TForm1.Edit1Change(Sender: TObject);
var
  c, i: Integer;
  s1, s2: string;
  sb: TScrollBar;
begin
  c := 4;
  for i := 1 to StringGrid1.RowCount-1 do
  begin
    s1 := UpperCase(StringGrid1.Cells[c, i]);
    s2 := UpperCase(Edit1.Text);
    if LeftStr(s1, Length(s2)) = s2 then
    begin
      StringGrid1.Col := c;
      StringGrid1.Row := i;
      Break;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PopulateGrid;
end;

procedure TForm1.PopulateGrid;
var
  book: TsWorkbook;
  sheet: TsWorksheet;
  i,j: Integer;
begin
  book := TsWorkbook.Create;
  try
    book.ReadFromFile('testfile.xls');
    sheet := book.GetWorksheetByIndex(0);
    StringGrid1.RowCount := sheet.GetLastRowIndex(true) + 2;;
    StringGrid1.ColCount := sheet.GetLastColIndex(true) + 2;
    for i:=0 to sheet.GetLastRowIndex do begin
      StringGrid1.Cells[0, i+1] := IntToStr(i);
      for j := 0 to sheet.GetLastColIndex do
        StringGrid1.Cells[j+1, i+1] := sheet.ReadAsUTF8Text(i, j);
    end;
  finally
    book.Free;
  end;
end;

end.

